Unit AFH0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFH0C(var A :Array of Complex; var S :Array of Real;
                N :Integer);

implementation

procedure AFH0C(var A :Array of Complex; var S :Array of Real;
                N :Integer);
var
J,J1,I,I1,K :Integer;
V :Real;
Z :Complex;
label
_1,_2,_3,_4,_5,_6;
begin
S[0] := Creal(DivC(Cmplx(1.0,0.0),A[0+0*N]));
J := 2;
J1 := 1;
goto _4;
_1:
J1 := J;
J := J+1;
for I:=2 to J1 do
 begin
  I1 := I-1;
  Z := A[(I-1)+(J-1)*N];
  for K:=1 to I1 do
   begin
_2:
    Z := SubC(Z,MulC(A[(K-1)+(J-1)*N],Conjg(A[(K-1)+(I-1)*N])));
   end;
_3:
  A[(I-1)+(J-1)*N] := Z;
 end;
_4:
V := Creal(A[(J-1)+(J-1)*N]);
for K:=1 to J1 do
 begin
  Z := A[(K-1)+(J-1)*N];
_5:
  V := Creal(SubC(Cmplx(V,0.0),MulC(MulC(Z,Conjg(Z)),Cmplx(S[K-1],0.0))));
 end;
S[J-1] := 1.0/V;
for I:=1 to J1 do
 begin
_6:
  A[(I-1)+(J-1)*N] := MulC(A[(I-1)+(J-1)*N],Cmplx(S[I-1],0.0));
 end;
if ( J <> N ) 
 then goto _1;
end;

end.
